function deb1() {
    let j = 200;
    let tab: number[] = []; // Déclaration du tableau
    for (let i = 0; i < 10; i++) {
        j -= 10; //point d'arret, permet de suivre les valeurs de j (Exo1)
        tab[i] = j; // Stocker j dans le tableau + point d'arret pour visualiser le remplissage du tableau (Exo2)
    }
    return j;
}

function deb2(x: number, y: number) : void {
    const tmp = y;
    y = x; //Point d'arret x = 10, 9, 8, ..., 1
    x = tmp; //Point d'arret y = 5, 6, 7, ..., 14
    console. log(x, y);
}
let x = 10;
let y = 20;
deb2(x, y);
console. log(x, y);
//Le programme peut ne pas fonctionner correctement si x ou y ne sont pas initialisés correctement 

function deb3(xy: number[]) : void {
    let tmp= xy[0] ;
    xy [0] = xy[1];
    xy [1] = tmp;
    console. log(xy);
}
let xy= [10, 20];
deb3(xy);
console. log(xy);
//Le programme fonctionne correctement si on ne modifie pas la référence du tableau

let j = 10; //crée une variable j globale avec la valeur 10
deb4();
console.log(j);

function deb4(): number {
let j = 25;//une nouvelle variable j locale à deb4 est créée et initialisée à 25
for (let i = 0; i < 10; i++) {
let j = 2 * i;
console.log(j); //Dans la boucle for, une autre variable j est définie avec let et modifiée à chaque itération (j = 2 * i
    }
return j;
}
//Après l'exécution de deb4(), la variable globale j reste 10 car les modifications dans deb4() ne l'affectent pas: let crée des variables avec une portée limitée au bloc où elles sont déclarées

let tab1 = [1, 2, 3];
let tab2 = tab1; //ne crée pas une copie mais une référence vers tab1
tab1[1] = 5; //modifie aussi tab2, car les deux variables pointent vers le même tableau en mémoire
console.log(tab1, tab2); 

let tab3 = [1, 2, 3];
let tab4 = [ ... tab1]; //[...] crée une copie indépendante du tableau
tab3[1] = 5; //n'affecte pas tab4
console. log(tab3, tab4);
//Dans le second cas, tab2 est une nouvelle copie indépendante de tab1, ce qui évite les modifications involontaires.

multiplication(5, 3);

function multiplication(x: number, y: number) : number { //deb7 devient multiplication
    if (y === 0) {
        return 0;}
    return x * y;
}

let n=5;
console.log(deb8(n));
function deb8(n: number): number {
    if (n === 0) {
        return 1;}
    let valeur = deb8(n-1);
    return valeur;
}